%{!?python_sitelib: %define python_sitelib %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

Summary: Creates a common metadata repository
Name: createrepo
Version: 0.9.9
Release: 29%{?dist}
License: GPLv2
Group: System Environment/Base
Source: %{name}-%{version}.tar.gz
Patch0: ten-changelog-limit.patch
Patch1: createrepo-head.patch
Patch2: BZ-833350-fix-tempfile-cachedir-permissions.patch
Patch3: BZ-865845-only-use-available-compression.patch
Patch4: BZ-874682-modifyrepo-default-compression.patch
# 6.5 fast
Patch11: BZ-877301-C-option-does-nothing-on-empty-repo.patch
Patch12: BZ-892657-fix-options-documentation.patch

# 6.6
Patch21: BZ-952602-modifyrepo-options.patch
Patch22: BZ-1083185-traceback-on-nonexisting-pkglist.patch
Patch23: BZ-1035588-cifs-share-oserror.patch
Patch24: BZ-1093713-modifyrepo-mergerepo-options-manpage.patch

# 6.8
Patch31: BZ-1175925-mergerepo-package-versions.patch
Patch32: BZ-1104840-checksum-prefix.patch
Patch33: BZ-1106454-no-compress.patch 

# 6.9
Patch41: BZ-1174380-fix-update-for-same-nevra.patch
Patch42: BZ-1297642-cleanup-temporary-files-in-var-tmp-on-exit.patch

# 6.10
Patch51: BZ-1434369-safety-check-oldData.patch
Patch52: BZ-1570864-clean-temp-files-crash.patch

# CERN
Patch61: CERN-clean-olddata.patch

URL: http://createrepo.baseurl.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArchitectures: noarch
Requires: python >= 2.1, rpm-python, rpm >= 0:4.1.1, libxml2-python
Requires: yum-metadata-parser, yum >= 3.2.29, python-deltarpm

BuildRequires: python

%description
A set of utilities for generating a common metadata repository
from a directory of rpm packages and maintaining it.

%prep
%setup -q

# This is divergent from upstream...
%patch0 -p0

# These are backports...
# HEAD at the time of the rebase.
%patch1 -p1

%patch2 -p1
%patch3 -p1
%patch4 -p1

# 6.5 fast
%patch11 -p1
%patch12 -p1

# 6.6
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1

# 6.8
%patch31 -p1
%patch32 -p1
%patch33 -p1

# 6.8
%patch41 -p1
%patch42 -p1

# 6.10
%patch51 -p1
%patch52 -p1

# CERN
%patch61 -p1

%build

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

# Hack for bash_completion.d
mv $RPM_BUILD_ROOT/usr/%{_sysconfdir} \
   $RPM_BUILD_ROOT/%{_sysconfdir}

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root, root,-)
%doc ChangeLog README COPYING
%{_datadir}/%{name}/
%{_sysconfdir}/bash_completion.d/
%{_bindir}/createrepo
%{_bindir}/modifyrepo
%{_bindir}/mergerepo
%{_mandir}/*/*
%{python_sitelib}/createrepo

%changelog
* Wed Feb 6 2019 Alex Iribarren <Alex.Iribarren@cern.ch> - 0.9.9-29
- Clean up .olddata directory.

* Tue Apr 24 2018 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-28
- Add safety check for conf.outputdata attribute.
- Resolves: bug#1570864

* Wed Jun 28 2017 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-27
- Add safety check for oldData attribute.
- Resolves: bug#1434369

* Fri Nov 04 2016 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-26
- Fix temporary files cleanup.
- Resolves: bug#1297642

* Mon Oct 31 2016 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-25
- Fix --update for pkgs with same nevra.
- Resolves: bug#1174380

* Tue Jan 05 2016 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-24
- Make sure filename doesn't already contain a checksum.
- Resolves: bug#1104840
- Remove nonexistent --no-compress option from the manpage.
- Resolves: bug#1106454

* Mon Dec 14 2015 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-23
- mergerepo: merge package versions from multiple repos.
- Resolves: bug#1175925

* Tue May 6 2014 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-22
- Add modifyrepo and mergrepo options to their manpages.
- Resolves: rhbz#1093713

* Thu Apr 17 2014 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-21
- Improve package description.
- Resolves: rhbz#1088886

* Tue Apr 8 2014 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-20
- Catch IOErrors when loading pkglist.
- Resolves: rhbz#1083185
- Fix OSError when running createrepo on CIFS shares.
- Resolves: rhbz#1035588

* Wed Apr 2 2014 Valentina Mukhamedzhanova <vmukhame@redhat.com> - 0.9.9-19
- Options --checksum, --unique-md-filenames, --simple-md-filenames for modifyrepo.
- Resolves: rhbz#952602

* Tue May 14 2013 James Antill <james.antill@redhat.com> - 0.9.9-18
- Option -C does nothing on empty repo.
- Resolves: rhbz#877301
- Fix the options documentation.
- Resolves: rhbz#892657

* Mon Nov 19 2012 James Antill <james.antill@redhat.com> - 0.9.9-17
- Use .gz as the default compression for modifyrepo.
- Document --compress-type in createrepo man page.
- Resolves: rhbz#874682

* Mon Oct 22 2012 James Antill <james.antill@redhat.com> - 0.9.9-16
- Only use available compression.
- Resolves: rhbz#865845

* Fri Oct  5 2012 James Antill <james.antill@redhat.com> - 0.9.9-15
- Tempfile ignores umask for files created in cache, use 666 not 777 as well.
- Resolves: rhbz#833350

* Thu Oct  4 2012 James Antill <james.antill@redhat.com> - 0.9.9-14
- Tempfile ignores umask for files created in cache.
- Resolves: rhbz#833350

* Fri Sep 14 2012 James Antill <james.antill@redhat.com> - 0.9.9-13
- Rebase to upstream 0.9.9.
- Createrepo should be multitasking (Rebase).
- Resolves: rhbz#631989
- Createrepo ignores umask for files in it's cache.
- Resolves: rhbz#833350
- Reduce memory usage for --update, by using sqlite instead of XML (Rebase).
- Resolves: rhbz#716235
- Support removing metadata from repodata, in modifyrepo.
- Resolves: rhbz#714094
- Fix createrepo to work with --split and --pkglist at the same time.
- Resolves: rhbz#646644

* Fri Feb  3 2012 Zdenek Pavlas <zpavlas@redhat.com> - 0.9.8-5
- Fix last instance of #!/usr/bin/env.
- Resolves: rhbz#623105

* Thu Jan  7 2010 James Antill <james.antill@redhat.com> - 0.9.8-4
- Allow baseurl option to update, when doing updates.
- Resolves: rhbz#552981
- Convert stat mtime to int, so comparison can succeed (for update).
- Resolves: rhbz#553030

* Thu Sep  3 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.8-2
- add drpm patch from https://bugzilla.redhat.com/show_bug.cgi?id=518658

* Fri Aug 28 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.8-1
- bump yum requires version
- remove head patch
- bump to 0.9.8 upstream

* Tue Aug 18 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.7-15
- update HEAD patch to include fix from mbonnet for typo'd PRAGMA in the filelists setup

* Tue Aug  4 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.7-14
- minor fix for rh bug 512610

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.7-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jun 17 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.7-11
- more profile output for deltarpms

* Tue Jun 16 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.7-8
- more patches from head
- speed up generating prestodelta, massively

* Tue May  5 2009 Seth Vidal <skvidal at fedoraproject.org>
- more head fixes - theoretically solving ALL of the sha1/sha silliness

* Wed Apr 15 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.7-2
- fix 495845 and other presto issues

* Tue Mar 24 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.7-1
- 0.9.7
- require yum 3.2.22

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.6-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Feb 10 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.6-11
- change the order of deltarpms

* Wed Feb  4 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.6-10
- working mergerepo again

* Tue Feb  3 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.6-9
- fix normal createrepo'ing w/o the presto patches :(

* Mon Feb  2 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.6-7
- add deltarpm requirement for making presto metadata

* Tue Jan 27 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.6-6
- one more patch set to make sure modifyrepo works with sha256's, too

* Mon Jan 26 2009 Seth Vidal <skvidal at fedoraproject.org> - 0.9.6-5
- add patch from upstream head for sha256 support

* Sat Nov 29 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 0.9.6-4
- Rebuild for Python 2.6

* Tue Oct 28 2008 Seth Vidal <skvidal at fedoraproject.org> - 0.9.6-1
- 0.9.6-1
- add mergerepo

* Thu Oct  9 2008 James Antill <james@fedoraproject.org> - 0.9.5-5
- Do atomic updates to the cachedir, for parallel runs
- Fix the patch

* Fri Feb 22 2008 Seth Vidal <skvidal at fedoraproject.org> - 0.9.5-2
- patch for the mistake in the raise for an empty pkgid

* Tue Feb 19 2008 Seth Vidal <skvidal at fedoraproject.org> - 0.9.5-1
- 0.9.5
- ten-changelog-limit patch by default in fedora

* Thu Jan 31 2008 Seth Vidal <skvidal at fedoraproject.org> - 0.9.4-3
- skip if no old metadata and --update was called.

* Wed Jan 30 2008 Seth Vidal <skvidal at fedoraproject.org> - 0.9.4-1
- 0.9.4

* Tue Jan 22 2008 Seth Vidal <skvidal at fedoraproject.org> - 0.9.3
- 0.9.3

* Thu Jan 17 2008 Seth Vidal <skvidal at fedoraproject.org> - 0.9.2-1
- remove all other patches - 0.9.2 

* Tue Jan 15 2008 Seth Vidal <skvidal at fedoraproject.org> 0.9.1-3
- more patches - almost 0.9.2 but not quite

* Thu Jan 10 2008 Seth Vidal <skvidal at fedoraproject.org> 0.9.1-2
- patch to fix bug until 0.9.2

* Wed Jan  9 2008 Seth Vidal <skvidal at fedoraproject.org> 0.9.1-1
- 0.9.1 

* Mon Jan  7 2008 Seth Vidal <skvidal at fedoraproject.org> 0.9-1
- 0.9
- add yum dep


* Mon Nov 26 2007 Luke Macken <lmacken@redhat.com> - 0.4.11-1
- Update to 0.4.11
- Include COPYING file and change License to GPLv2

* Thu Jun 07 2007 Paul Nasrat <pnasrat@redhat.com> - 0.4.10-1
- Update to 0.4.10

* Wed May 16 2007 Paul Nasrat <pnasrat@redhat.com> - 0.4.9-1
- Update to 0.4.9

* Tue May 15 2007 Jeremy Katz <katzj@redhat.com> - 0.4.8-4
- fix the last patch

* Tue May 15 2007 Jeremy Katz <katzj@redhat.com> - 0.4.8-3
- use dbversion given by yum-metadata-parser instead of hardcoded 
  value (#239938)

* Wed Mar 14 2007 Paul Nasrat <pnasrat@redhat.com> - 0.4.8-2
- Remove requires (#227680)

* Wed Feb 21 2007 Jeremy Katz <katzj@redhat.com> - 0.4.8-1
- update to 0.4.8

* Mon Feb 12 2007 Jesse Keating <jkeating@redhat.com> - 0.4.7-3
- Require yum-metadata-parser.

* Thu Feb  8 2007 Jeremy Katz <katzj@redhat.com> - 0.4.7-2
- add modifyrepo to the file list

* Thu Feb  8 2007 Jeremy Katz <katzj@redhat.com> - 0.4.7-1
- update to 0.4.7

* Mon Feb 05 2007 Paul Nasrat <pnasrat@redhat.com> - 0.4.6-2
- Packaging guidelines (#225661)

* Thu Nov 09 2006 Paul Nasrat <pnasrat@redhat.com> - 0.4.6-1
- Upgrade to latest release
- Fix requires (#214388)

* Wed Jul 19 2006 Paul Nasrat <pnasrat@redhat.com> - 0.4.4-2
- Fixup relative paths (#199228)

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 0.4.4-1.1
- rebuild

* Mon Apr 17 2006 Paul Nasrat <pnasrat@redhat.com> - 0.4.4-1
- Update to latest upstream

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Fri Nov 18 2005 Paul Nasrat <pnasrat@redhat.com> - 0.4.3-5
- Fix split with normalised directories

* Fri Nov 18 2005 Paul Nasrat <pnasrat@redhat.com> - 0.4.3-4
- Another typo fix
- Normalise directories

* Thu Nov 17 2005 Paul Nasrat <pnasrat@redhat.com> - 0.4.3-3.1
- really fix them 

* Thu Nov 17 2005 Paul Nasrat <pnasrat@redhat.com> - 0.4.3-3
- Fix regressions for absolute/relative paths

* Sun Nov 13 2005 Paul Nasrat <pnasrat@redhat.com> - 0.4.3-2
- Sync upto HEAD 
- Split media support

* Thu Jul 14 2005 Paul Nasrat <pnasrat@redhat.com> - 0.4.3-1
- New upstream version 0.4.3 (cachedir support)

* Tue Jan 18 2005 Jeremy Katz <katzj@redhat.com> - 0.4.2-2
- add the manpage

* Tue Jan 18 2005 Jeremy Katz <katzj@redhat.com> - 0.4.2-1
- 0.4.2

* Thu Oct 21 2004 Paul Nasrat <pnasrat@redhat.com>
- 0.4.1, fixes #136613
- matched ghosts not being added into primary.xml files

* Mon Oct 18 2004 Bill Nottingham <notting@redhat.com>
- 0.4.0, fixes #134776

* Thu Sep 30 2004 Paul Nasrat <pnasrat@redhat.com>
- Rebuild new upstream release - 0.3.9

* Thu Sep 30 2004 Seth Vidal <skvidal@phy.duke.edu>
- 0.3.9
- fix for groups checksum creation

* Sat Sep 11 2004 Seth Vidal <skvidal@phy.duke.edu>
- 0.3.8

* Wed Sep  1 2004 Seth Vidal <skvidal@phy.duke.edu>
- 0.3.7

* Fri Jul 23 2004 Seth Vidal <skvidal@phy.duke.edu>
- make filelists right <sigh>


* Fri Jul 23 2004 Seth Vidal <skvidal@phy.duke.edu>
- fix for broken filelists

* Mon Jul 19 2004 Seth Vidal <skvidal@phy.duke.edu>
- re-enable groups
- update num to 0.3.4

* Tue Jun  8 2004 Seth Vidal <skvidal@phy.duke.edu>
- update to the format
- versioned deps
- package counts
- uncompressed checksum in repomd.xml


* Fri Apr 16 2004 Seth Vidal <skvidal@phy.duke.edu>
- 0.3.2 - small addition of -p flag

* Sun Jan 18 2004 Seth Vidal <skvidal@phy.duke.edu>
- I'm an idiot

* Sun Jan 18 2004 Seth Vidal <skvidal@phy.duke.edu>
- 0.3

* Tue Jan 13 2004 Seth Vidal <skvidal@phy.duke.edu>
- 0.2 - 

* Sat Jan 10 2004 Seth Vidal <skvidal@phy.duke.edu>
- first packaging

